

///#pragma comment(lib, "tasandid4_18_combined_project.lib")


///#pragma warning (disable: 4503 4786)				  			

///#define INCLUDE_BOOST_BINARY_ARCHIVE
///#include "tasandid_stdafx.h"
#include <iostream>




#define USE_BLENDED_STATUS_VECTOR 0
static int num_echoline_outputcells = 4;
bool enable_screen = true;




#define NET_DECLARE_ONLY
#include "debug_semaphore.h"
#include "tasand1_operant_net/operant_net.h"
#include "tasand3_comb_cells/comb_cells2.h"								   ///its good idea to include this as last include, because it defines mutiple shortcut definitions that might conflict with other headers otherwise
//#include "tasand2/pattern_cell.h"											   ///class PIXEL_A
#include "tasand1_echo_lines/echo_lines.h"								   ///its good idea to include this as last include, because it defines mutiple shortcut definitions that might conflict with other headers otherwise
#include "datastructures/status_vector.h"




#define USE_OPERANT_NET 0


#if !USE_OPERANT_NET
typedef ai::assoc_net_1_with_echolines_and_nonlinear_assoc_cells						tasandid_server_net_type;
//typedef ai::assoc_net_1_with_echolines_and_nonlinear_assoc_cells_and_comb_cells		tasandid_server_net_type;
#else
typedef ai::simple_operant_net_1_with_echolines											tasandid_server_net_type;
#endif




#define NUM_NET_BASE_INPUTS								4
#define MAX_NUM_DISPLAY_CHARTS							3
#define CHART_HEIGHT									36
#define MAX_NONLINEAR_ASSOC_CELL_POINTS_TO_SHOW			4





using namespace std;

using namespace ai;
using namespace linked_list;






tasandid_server_net_type *net;



void testfunc();



#ifdef _DEBUG_EXE

void __cdecl main()
{
	testfunc();
}				

#endif	


void docycles(/*tasandid_server_net_type *net*/)
///void docycles(tasand_1_net *net)
{
	for (int c = 1; c < 1000; c++)
	{
	
		float val;
		for (int i = 0; i < net->get_num_inputs(); i++)
		{
			val = (float)rand();
			val = val / (float)RAND_MAX;
			
			
			///if (i == 42)
			///	BREAK;
			
			
			net->set_input_atindex(i, val);
		}
		
		for (int o = 0; o < net->get_num_outputs(); o++)
		{
			val = (float)rand();
			val = val / (float)RAND_MAX;
			net->set_output_atindex(o, val);
		}
		
		
		cout << c << endl;
		
		

		net->tick_echo_lines();
		net->calc_predictions();

		net->update_corrs();
		net->prepare_for_next_cycle();

	}

}	


void cycle(bool learn)
{

	net->set_input_cv_atindex(0, 0);
	//net->set_input_cv_atindex(1, 0);

	net->set_output_cv_atindex(0, 1);
	
	
	
	net->tick_echo_lines();
	net->calc_predictions();
		
	
	cell_value predicted_val = net->get_output_cv_predicted_val_atindex(0);		 ///(NB! note that for operant net this must be called AFTER update_corrs, if you intend to call update_corrs at all, else you should call calc_operant_predictions before get_outputs)
		
	
	if (learn)
	{
		net->update_corrs();
	}
	

	net->prepare_for_next_cycle();
	
}
			   
											 
void testfunc()
{

	///ai::assoc_net_1_with_echolines *net = new ai::assoc_net_1_with_echolines();
	///ai::tasand_1_net net; // = new ai::tasand_1_net();
	///base_cell_ct<> cell;

///#pragma warning(disable : 4269 4503 4786)	
	///const cell_with_value_diff_calc		value;
	
	
	net = new tasandid_server_net_type();
	
	///tasand_1_net					*net = new tasand_1_net();
	
	
	///assoc_net_1_with_echolines		*value = &value1;
	///const tasand_1_net		value;
	///segmented_linked_list_customsize__with_container_obj_ptr<base_cell, DSS, void>		*value;
///#pragma warning(default : 4269 4503 4786)	
	

	net->set_num_inputs(1);
	net->set_num_outputs(1);
#if USE_OPERANT_NET					
	net->set_num_operants(1);		///right now we use only one operant - whether we are on line or not
#endif			
	net->set_num_echoline_outputcells(num_echoline_outputcells);



	
	do 
	{
		///cycle(false);
		cycle(true);
	} 
#pragma warning (push)
#pragma warning (disable : 4127)	
	while(1);
#pragma warning (pop)




#if 0
	docycles(net);	

	
	net->save();



	net->load();
	
	
	docycles(net);					
#endif  
	  
	  
#if 0
						
	//char *data;
	//size_t data_len;
	std::ofstream os;
	
	
	//TODO: write data to file
	//int handle = _open("net.data", _O_BINARY | _O_CREAT | _O_SEQUENTIAL | _O_TRUNC | _O_WRONLY, /*std::ios::out*/_S_IWRITE);
	os.open("net.data", std::ios_base::out | std::ios::binary); 
	if (os.is_open())		
	{
		//std::ostringstream os(filebuf);			
		boost::archive::binary_oarchive oa(os);
		//ai::assoc_net_1_with_echolines net_tmp = *net;
		
		
		

#pragma warning (disable: 4503 4786)
		oa << *value; 
//#pragma warning (default: 4503 4786)				  	//the warning cant be enabled anymore in this file, for some strange reason, or warnings follow in compilation		
		
		//std::string str = os.str();	
		
		//data = str.c_str();
		//data_len = str.size();
	
	
	
		//_close(handle);
		os.close();
	}

#endif	
	
	

	//delete net;
}


//#pragma warning (default: 4503 4786)				  			
